#################################s#o#q######################################
## by Arthur Chan @ soqhome.com
#############################################################################


from zLOG import LOG, WARNING, BLATHER, INFO

from OFS.ObjectManager import ObjectManager
from Acquisition import aq_parent, aq_chain, aq_inner

import CMFFolder
import CMFFolderTool


from Products.CMFDefault import Portal
from Products.Archetypes.public import *
from Permissions import *
#import Products.CMFCore
from Products.CMFCore import utils #, CMFCorePermissions
from Products.CMFCore.DirectoryView import registerDirectory
from config import *

import os, os.path

registerDirectory(SKINS_DIR, globals())



def initialize(context):
    ##Import Types here to register them
    
    ##Import Types here to register them


    content_types, constructors, ftis = process_types(
        listTypes(PROJECTNAME),
        PROJECTNAME)
    
    utils.ContentInit(
        PROJECTNAME + ' Content',
        content_types      = content_types,
        permission         = AddCMFFolder,
        extra_constructors = constructors,
        fti                = ftis,
        ).initialize(context)

    tools = ( CMFFolderTool.CMFFolderTool, ) 

    utils.ToolInit('CMFFolder Tool', tools=tools, 
                       product_name='CMFFolder', icon='tool.gif',  
                       ).initialize(context) 

