#################################s#o#q######################################
## by Arthur Chan @ soqhome.com
#############################################################################

##############s#o#q###################
from Products.Archetypes.public import listTypes
from Products.Archetypes.Extensions.utils import installTypes, install_subskin
from Products.CMFCore.utils import getToolByName, ToolInit
from StringIO import StringIO

from Products.CMFFolder.config import *

from StringIO import StringIO

def install_tools(self, out):
    portal_url = getToolByName(self, 'portal_url')
    p = portal_url.getPortalObject()
    if not hasattr(p, "cmffolder_tool"):
        x = p.manage_addProduct['CMFFolder'].manage_addTool(type="CMFFolder Tool")
        print >>out, "Install Tool okay"
    else:
        print >>out, "Tool already exists."

def install_slot(self, out):
    portal = getToolByName(self,'portal_url').getPortalObject()
    
    slotpath = 'here/cmffolder_slot/macros/quotaBox'
    
    try: #try to install the slot (bare except, because it will fail on bare CMF)
        if not slotpath in portal.right_slots:
            portal.right_slots = list(portal.right_slots) + [slotpath,]
            print >>out, "Inserted CMFFolder Slot"
        else:
            print >>out, "The CMFFolder slot already exists"
    except: 
        print >>out, "Cannot insert the notes slot"
        pass
    
def install(self):

    out = StringIO()
    
    
    install_tools(self, out)
    install_slot(self, out)
    
    installTypes(self, out,
                 listTypes(PROJECTNAME),
                 PROJECTNAME)

    install_subskin(self, out, GLOBALS)

    portal = getToolByName(self,'portal_url').getPortalObject()

    #register the folderish items in portal_properties/site_properties for folder-contents views etc
    site_props = getToolByName(self, 'portal_properties').site_properties
    use_folder_tabs = site_props.getProperty('use_folder_tabs')
    if not 'CMFFolder' in use_folder_tabs:
        site_props._updateProperty('use_folder_tabs', tuple(use_folder_tabs) + ('POFolder',))
    
    use_folder_contents = site_props.getProperty('use_folder_contents')
    if not 'CMFFolder' in use_folder_tabs:
        site_props._updateProperty('use_folder_contents', tuple(use_folder_tabs) + ('POFolder',))
        
   
    # add the workflow
    try:
        wf_tool = getToolByName(self, 'portal_workflow')
        wf_tool.setChainForPortalTypes(('POFolder', ), 'folder_workflow')
        
    except:
        print >> out, "Didn't succeed creating and attaching workflows %s." % PROJECTNAME

    # turn off some actions by default for the types (they can be turned on by the admin when necessary, for beginners they are confusing):
    # properties, references
    try:
        pt = self.portal_types
        pt.POFolder._actions[2].visible=0
        pt.POFolder._actions[3].visible=0
    except:
        pass
        
    print >> out, "Successfully installed %s." % PROJECTNAME
    return out.getvalue()



